<?php

/**
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license. If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Troubleticket
 * @package    QuickTicket
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @version    2.2 build:20090816
 * @link       http://www.qt-cute/doc/package/qti
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 3.0.0
 */

session_start();
require_once('bin/qti_init.php');
include(Translate('qti_adm.php'));
include(Translate('qtim_import.php'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

// INITIALISE

$strTitle = '';
$strFormat = 'CSV';
$strDelimit = ';';
$strEnclose = '"';
$strNull = 'NULL';
$strDropbbc = 'N';
$strSkip = 'Y';
$strStatus = 'Z';
$intSection = -1;

$oVIP->selfurl = 'qtim_import_adm.php';
$oVIP->selfname = $L['import']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['import']['Version'].' 2.2<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check file
  
  $error = InvalidUpload($_FILES['title'],'csv,txt,text,sql');

  // check form value

  if ( empty($error) )
  {
    $strFormat = trim($_POST['format']);
    $strDelimit = trim($_POST['delimit']);
    if ( $strFormat=='SQL' ) $strDelimit = ',';
    $strEnclose = $_POST['enclose']; if ( get_magic_quotes_gpc() ) $strEnclose = stripslashes($_POST['enclose']);
    $strNull = trim($_POST['null']);
    if ( isset($_POST['dropbbc']) ) $strDropbbc='Y';
    if ( isset($_POST['skip']) ) $strSkip='Y';
    if ( empty($strDelimit) ) $error=$L['import']['Delimiter'].S.$L['E_invalid'];
    $intSection = intval($_POST['section']);
    $strStatus = $_POST['status'];
    $_SESSION['m_import']=array($strTitle,$strFormat,$strDelimit,$strEnclose,$strNull,$strDropbbc,$strSkip,$intSection,$strStatus);
  }

  // check values

  if ( empty($error) )
  {
    if ( strlen($strDelimit)==1 )
    {
    if ( ereg("[0-9A-Za-z]",$strDelimit) ) $error=$L['import']['Delimiter'].S.$L['E_invalid'];
    }
    if ( strlen($strEnclose)==1 )
    {
    if ( ereg("[0-9A-Za-z]",$strEnclose) ) $error=$L['import']['Enclose'].S.$L['E_invalid'];
    }
  }

  // save and run

  if ( empty($error) )
  {
    if ( empty($_POST['null']) ) { $strNull=S; } else { $strNull=$_POST['null']; }

    // read lines
    $handle = fopen($_FILES['title']['tmp_name'],'r');
    if ( $handle )
    {
      if ( $strSkip=='Y' ) $str = fgets($handle);

      // -----
      $i = 0;
      $intCountPost = 0;
      $intCountTopic = 0;
      $intNextTopic = Nextid(TABTOPIC);

      while ( !feof($handle) )
      {
        $i++;
        $str = fgets($handle);
        if ( strlen($str)<4 ) continue;

        if ( $strFormat=='SQL' )
        {
        $str = trim(strstr($str,'VALUES ('));
        $str = substr($str, 8, -1);
        }
        // bbc html
        if ( $strDropbbc=='Y' )
        {
        $str = QTbbc($str,'drop',null,null,null,null,' ');
        }

        // import line (0:id 1:section 2:topic 3:type 4:username 5:title 6:issuedate 7:numid 8:textmsg 9:x 10:y 11:z
        if ( substr_count($str, $strDelimit)>7 )
        {
          $arrStr = explode($strDelimit,$str);

          if ( count($arrStr)==9 )
          {
            $arrStr[] = '0'; // add x,y,z if import from version 1.7
            $arrStr[] = '0';
            $arrStr[] = '0';
          }
          if ( count($arrStr)==12 )
          {
            // pre-process values, remove encloser, html quote
            For ($j=0;$j<12;$j++)
            {
              $arrStr[$j]=trim($arrStr[$j]);
              if ( substr($arrStr[$j],0,1)==$strEnclose && substr($arrStr[$j],-1,1)==$strEnclose ) $arrStr[$j]=substr($arrStr[$j],1,-1);
              $arrStr[$j] = htmlspecialchars($arrStr[$j],ENT_QUOTES);
            }

            $intPost    = Nextid(TABPOST);
            $intTopic   = $intNextTopic+$arrStr[2];
            $strType    = ($arrStr[3]==$strNull ? 'NULL' : '"'.$arrStr[3].'"');
            $strUsername= ($arrStr[4]==$strNull ? '"Visitor"' : '"'.addslashes($arrStr[4]).'"');
            $strTitle   = ($arrStr[5]==$strNull ? 'NULL' : '"'.addslashes($arrStr[5]).'"');
            $strIssue   = ($arrStr[6]==$strNull ? '"0"' : '"'.substr($arrStr[6],0,8).' '.substr($arrStr[6],-6,6).'"');
            $intNumid   = $arrStr[7];
            $strTextmsg = '"'.addslashes($arrStr[8]).'"';
            $strX = ($arrStr[9]==$strNull ? '0' : $arrStr[9]);
            $strY = ($arrStr[10]==$strNull ? '0' : $arrStr[10]);
            $strZ = ($arrStr[11]==$strNull ? '0' : $arrStr[11]);
            $strS = '"'.$strStatus.'"';
            $strSD = '"'.date('Ymd His').'"';
            $oDB->Query( 'INSERT INTO '.TABPOST." (id,forum,topic,type,userid,username,title,issuedate,textmsg) VALUES ($intPost,$intSection,$intTopic,$strType,0,$strUsername,$strTitle,$strIssue,$strTextmsg)" );
            $intCountPost++;

            if ( ($arrStr[3]=='P') || ($arrStr[3]=='A') )
            {
              if ( $arrStr[3]=='P' ) $strType='"T"';
              if ( $arrStr[4]=='NULL' ) $arrStr[4]='Visitor';
              $oDB->Query( 'INSERT INTO '.TABTOPIC." (id,numid,forum,type,status,statusdate,firstpostid,lastpostid,firstpostuser,lastpostuser,firstpostname,lastpostname,firstpostdate,lastpostdate,x,y,z) VALUES ($intTopic,$intNumid,$intSection,$strType,$strS,$strSD,$intPost,$intPost,0,0,$strUsername,$strUsername,$strIssue,$strIssue,$strX,$strY,$strZ)" );
              $intCountTopic++;
            }
          }
          else
          {
            $error='Number of parameters ('.count($arrStr).') not matching in line '.$i;
          }
        }
        else
        {
        $error='Not enough delimiters ('.substr_count($str, $strDelimit).') in line '.$i;
        }
      }
      // ----
      fclose($handle);

      // update stats
      if ( $intCountPost>0 || $intCountTopic>0 )
      {
      UpdateSectionStats($intSection,true,true); // update stats and re-compute lastpostdate,replies of the topic
      }
    }
  }

  if ( empty($error) )
  {
    unlink($_FILES['title']['tmp_name']);
    $oVIP->EndMessage(NULL,$L['import']['S_import'],'admin',0);
  }
}

// --------
// HTML START
// --------

$bJava=false;

include('qti_adm_p_header.php');
include('qti_adm_p_title.php');

if ( isset($_SESSION['m_import']) )
{
$strTitle   = $_SESSION['m_import'][0];
$strFormat  = $_SESSION['m_import'][1];
$strDelimit = $_SESSION['m_import'][2];
$strEnclose = $_SESSION['m_import'][3];
$strNull    = $_SESSION['m_import'][4];
$strDropbbc = $_SESSION['m_import'][5];
$strSkip    = $_SESSION['m_import'][6];
$intSection = $_SESSION['m_import'][7];
$strStatus  = $_SESSION['m_import'][8];
}

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
-->
</script>
';

echo '<form method="post" action="',$oVIP->selfurl,'" enctype="multipart/form-data" onsubmit="return ValidateForm(this);">
<input type="hidden" name="maxsize" value="5242880"/>
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="th_o th_o_all" colspan="2">',$L['import']['File'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first" style="width:200px"><label for="title">',$L['import']['File'],'</label></td>
<td class="td_o"><input type="file" id="title" name="title" size="32" value="',$strTitle,'"/></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="2">',$L['Adm_settings'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="format">',$L['import']['Format'],'</label></td>
<td class="td_o"><select id="format" name="format">
<option value="CSV"',($strFormat=='CSV' ? QSEL : ''),'>',$L['import']['Csv'],'</option>
<option value="SQL"',($strFormat=='SQL' ? QSEL : ''),'>',$L['import']['Sql'],'</option>
</select></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="delimit">',$L['import']['Delimiter'],'</label></td>
<td class="td_o"><input type="text" id="delimit" name="delimit" size="1" maxlength="5" value="',$strDelimit,'"/></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="enclose">',$L['import']['Encloser'],'</label></td>
<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="5" value="',htmlspecialchars($strEnclose),'"/></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="null">',$L['import']['Null'],'</label></td>
<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$strNull,'"/> ',$L['import']['H_Null'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['import']['First_line'],'</td>
<td class="td_o"><input type="checkbox" id="skip" name="skip"',($strSkip=='Y' ? QCHE : ''),'/> <label for="skip">',$L['import']['HFirst_line'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="2">',$L['Destination'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first" style="width:200px"><label for="section">',$L['import']['Destination'],'</label></td>
<td class="td_o"><select id="section" name="section">',QTasTag(GetSectionTitles('A')),'</select> <a href="qti_adm_sections.php">',$L['Section_add'],'</a></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['import']['Drop_bbc'],'</td>
<td class="td_o"><input type="checkbox" id="dropbbc" name="dropbbc"',($strDropbbc=='Y' ? QCHE : ''),'/> <label for="dropbbc">',$L['import']['HDrop_bbc'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="status">',$L['Status'],'</label></td>
<td class="td_o"><select id="status" name="status">
';
foreach($oSYS->statuses as $strKey=>$arrValues)
{
echo '<option value="',$strKey,'"',($strStatus==$strKey ? QSEL : ''),'>',$strKey.' '.$arrValues['name'].'</option>',N;
}
echo '</select></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="2" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Ok'],'"/></td>
</tr>
</table>
</form>
';

// HTML END

include('qti_adm_p_footer.php');

?>